#define WIN32_LEAN_AND_MEAN  // just say no to MFC

#include <windows.h>   // include all the windows headers
#include <windowsx.h>  // include useful macros
#include <mmsystem.h>  // very important and include WINMM.LIB too!
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vector.h>
#include <time.h>
#include <iomanip.h>
#include <iostream>
#include <fstream>
#include <mmsystem.h>
#include <resources.h>

using namespace std;
extern "C" {
#include "Cards.h"     //This is the card library I used in this game.
                       //It uses cards32.dll which comes with nearly all
                       //verions of Windows. This simplified the programming
                       //because all the card bitmaps are already created
                       //and has easy to use drawing functions.
}
// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"
#define NEW_GAME 1
#define PLAYER_WINS 2
#define CPU_WINS 3


// The card structure. A big list of these will be created for the deck.
struct card {
    int card_map;
    int rank;
    int suit;
    int place;
    int x1;
    int y1;
    int x2;
    int y2;
    int def_pos;
};


    
vector<card> deck; //The 52 card deck, right now its empty


HWND      main_window_handle = NULL; // globally track main window
HINSTANCE hinstance_app      = NULL; // globally track hinstance
int attack_count;
int dxCard;
int dyCard;
int glbl_x;  //mouse x
int glbl_y;  //mouse y
int last_card;
int turn = 0;
int attack_pos;
int attack_ctr;
int trump;   //the trump
int attack;
int player1_card_count = 0;
int player2_card_count = 0;
int story = 0;
int total_story = 1;
int tutorial = 0;
int about = 0;



// FUNCTIONS //////////////////////////////////////////////

int defend(card card1, card card2) //defending card, attacking card
{

    if((card1.suit == card2.suit)&&(card1.rank == 0))
    {   
        return 1; 
    }
    if((card1.suit == trump)&&(card2.suit != trump))     
    {
        return 1; 
    }
    if((card1.suit == trump)&&(card2.suit == trump)&&(card1.rank == 0))
    {
        return 1; 
    }
    if((card2.rank != 0)&&(card1.suit == card2.suit)&&(card1.rank > card2.rank))
    {
        return 1; 
    }    
    return 0; 
}
    
    
void failure(int player) //if a player cannot defend, they must pick up all cards in play
{
    for(int a = 0; a < deck.size(); a++)
    {
        deck[a].def_pos = 55;
        if((deck[a].place==3)||(deck[a].place==4))
        {
            deck[a].x1 = 0;
            deck[a].x2 = 0;
            deck[a].y1 = 0;
            deck[a].y2 = 0;
            deck[a].place = player;
        }
    }
    return;
}        
 
void draw() //once all is done, players with less than 6 cards will draw cards
{
    int counter1 = 0;
    int counter2 = 0;
    int exist = 0;
    for(int a = 0; a < deck.size(); a++)   
    {
        if(deck[a].place==1) counter1++;
        if(deck[a].place==2) counter2++;
    }
    while(counter1 < 6)
    {   
        exist = 0;
        for(int a = 0; a < deck.size(); a++)
        {
            if(deck[a].place==0)
            {
                deck[a].place=1;
                a = deck.size();
                counter1++;
                exist = 1;
            }    
            
        }    
        if (exist == 0)
        {
            counter1 = 6;
        }
    }        
    
    while(counter2 < 6)
    {   
        exist = 0;
        for(int a = 0; a < deck.size(); a++)
        {
            if(deck[a].place==0)
            {
                deck[a].place=2;
                a = deck.size();
                counter2++;
                exist = 1;
            }    
            
        }    
        if (exist == 0)
        {
            counter2 = 6;
        }
    }   
}    
    
void remove_cards() //a successful defence will remove all cards in play
{
    for(int a = 0; a < deck.size(); a++)
    {
        if((deck[a].place == 3)||(deck[a].place == 4))deck[a].place = 9;
    }
    
    return;
                     
}       
    
    

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context



char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	
     case WM_COMMAND:
         {
             if(LOWORD(wparam) == 100) //if the user clicks on the Random Game button
             {
                 story = 0;
                 PostMessage(hwnd, WM_USER, NEW_GAME,0);
             } 
                   
             if(LOWORD(wparam) == 200) //story game
             {
                 story = 1;
                 total_story = 1;
                 PostMessage(hwnd, WM_USER, NEW_GAME,0);
                 
             } 
                             
             if(LOWORD(wparam) == 300) //quit
             {
               PostMessage(hwnd, WM_DESTROY, 0,0); 
                                                                             
             }
             
             if(LOWORD(wparam) == 400) //pass turn
             {
               if((turn == 2)||(turn == 3)) 
               {
                   turn = 2;
                   draw();
                   failure(1);
               }    
               if(turn == 1) 
               {
                   remove_cards();
                   draw();
                   turn = 2; 
               }    
             
                                                                        
             }                                                                     
             if(LOWORD(wparam) == 500) //tutorial
             {
               tutorial = 1; 
                                                                             
             }  
             
             if(LOWORD(wparam) == 600) //about
             {
               about = 1; 
                                                                             
             }                                                                      
          } 
          break;        
	    
    case WM_USER:
      {
          switch(wparam)
          {
              
          case PLAYER_WINS: //some you win messages
              {
               hdc = GetDC(hwnd);
               BeginPaint(hwnd,&ps);                  
               for(int a = 0; a < 10000; a++)
               {
                HPEN colors = CreatePen(PS_SOLID, 1, RGB(rand()%256, rand()%256, rand()%256));
                MoveToEx(hdc, rand()%600,0, NULL);   
                LineTo(hdc, rand()%600, 460);
                sprintf(buffer," You WIN!! ");
                TextOut(hdc, rand()%600,rand()%460, buffer, strlen(buffer));
                if (story == 1) total_story++;
                if (total_story == 5)
                 {
                  sprintf(buffer," You are the winner of the world!! ");
                  TextOut(hdc, rand()%350,rand()%460, buffer, strlen(buffer));
                  story = 0; total_story = 0;
   	             }    
                               
               }           
                          
                EndPaint(hwnd,&ps);
                ReleaseDC(hwnd, hdc); 
                PostMessage(hwnd, WM_USER, NEW_GAME,0);
                              
                                  
                                      
                                          
               }        
               break;
           case CPU_WINS: //you lose
               {
               hdc = GetDC(hwnd);
               BeginPaint(hwnd,&ps);                  
               for(int a = 0; a < 10000; a++)
               {
                HPEN colors = CreatePen(PS_SOLID, 1, RGB(rand()%256, rand()%256, rand()%256));
                MoveToEx(hdc, rand()%600,0, NULL);   
                LineTo(hdc, rand()%600, 460);
                sprintf(buffer," You LOSE!! ");
                story = 0; total_story = 0;
   	            TextOut(hdc, rand()%600,rand()%460, buffer, strlen(buffer));
                               
               }           
                          
                EndPaint(hwnd,&ps);
                ReleaseDC(hwnd, hdc); 
                PostMessage(hwnd, WM_USER, NEW_GAME,0);               
               
               
               
               
               
                }
                break;
              
              
              
              
              
              
          case NEW_GAME: //will initialize the deck
              {
                  turn = 0;
                  while(deck.size()>0)
                  {
                      deck.erase(deck.begin(),deck.begin()+1);
                  }
                
                  attack_ctr = 0;
                  int suit, rank;
                  int x1, y1;
                  int x2, y2;
                  int exist = 0;
                  

                  while(deck.size() < 52)
                  {
                          exist = 0;
                          suit = rand()%4;
                          rank = rand()%13;
                          
                          for(int a = 0; a < deck.size(); a++)
                          {
                              if((deck[a].suit == suit)&&(deck[a].rank == rank))
                              { exist = 1; }
                              
                              
                          } //for(int a = 0; a < deck.size(); a++)
                          if(exist == 0)
                          {
                              card new_card;
                              new_card.suit = suit;
                              new_card.rank = rank;
                              new_card.def_pos = 55;
                              new_card.place = 9;
                              if(rank > 4) new_card.place = 0;
                              if(rank == 0) new_card.place = 0;
       
                              
                              deck.push_back(new_card);
                              
                          } // if(exist = 0)   
                          
                  }  
                  
                  int ctr = 0;
                  int pos = 0;
                  last_card = deck.size();
                  
                  trump = deck[last_card].suit;

                  deck[last_card].x1 = 450;
                  deck[last_card].y1 = 450;
                  deck[last_card].x2 = 500;
   	              deck[last_card].y2 = 575;
                 
                  
                  while(ctr < 6) 
                  {
                       if(deck[pos].place == 0) 
                       {
                           deck[pos].place = 1;
                           ctr++;
                       }
                       pos++;
                  } 
                   
                  ctr = 0; 
                  player1_card_count = 6;
                      
                  while(ctr < 6) 
                  {
                       if(deck[pos].place == 0) 
                       {
                           deck[pos].place = 2;
                           ctr++;
                       }
                       pos++;
                  }  
                       
                  for(int a = deck.size(); a > 0; a--)
                  {
                        if(deck[a].rank > 4)
                        {
                            last_card = a;
                            a = 0;
                        }        
                  }    
                  
                  player2_card_count = 6;
                    
                       
                       
                  PostMessage(hwnd, WM_PAINT, 0,0);
              } //case NEW_GAME
              break;
          } //switch(wparam)   
                  
      }//case WM_USER:
      break;    
       
 
 
	case WM_CREATE: 
        {
         PostMessage(hwnd, WM_USER, NEW_GAME,0);
	     return(0);
		} break;


    case WM_LBUTTONDOWN:
        {
        
            if(turn == 0) //its players turn and they clicked on something
            {   attack = 0;
                int temp_pos = 0;
                
                for(int a = deck.size(); a >= 0; a--)
                {
                    if((glbl_x >= deck[a].x1) &&
                      (glbl_y >= deck[a].y1) &&
                      (glbl_x < deck[a].x2) &&
                      (glbl_y < deck[a].y2) &&
                      (deck[a].place==1))
                    {
                        temp_pos = a;
                        attack = 1;
                        deck[a].place = 3;
                        

                        
                        deck[a].x1 = 0;
                        deck[a].x2 = 0;
                        deck[a].y1 = 0;
                        deck[a].y2 = 0;
                        
                        a = 0;
                    }    
                }
                int defended = 0;
                if(attack == 1)
                {
                for(int b = 0; b <= deck.size(); b++) //cpu ai defend
                {
                    if((deck[b].place == 2)&&(defend(deck[b], deck[temp_pos])==1))    
                    {
                        defended = 1;
                        deck[b].place = 4;
                        
                        deck[temp_pos].def_pos = b;

                        
                        b = deck.size();
                        SendMessage(hwnd, WM_PAINT, 0,0);
                        turn = 1;
                    }    
                    
                }
                if(defended == 0)
                {
                    draw();
                    failure(2);
                    
                    
                } 
              }       
            }    
        
            if(turn == 1) //second round or more of attacks
            {
                int temp_pos = 0;
                int legal = 0;
                attack = 0;
                for(int a = deck.size(); a >= 0; a--)
                {
                    if((glbl_x >= deck[a].x1) &&
                      (glbl_y >= deck[a].y1) &&
                      (glbl_x < deck[a].x2) &&
                      (glbl_y < deck[a].y2) &&
                      (deck[a].place==1))
                    {
                        temp_pos = a;
                        
                        for(int b = 0; b < deck.size(); b++)
                        {
                            if((deck[b].rank == deck[a].rank)&&((deck[b].place == 3)||(deck[b].place == 4))) legal = 1;
                            
                        }
                        
                        if(legal == 1)
                        {
                        
                        attack = 1;
                        deck[a].place = 3;
                        temp_pos = a;
                        deck[a].x1 = 0;
                        deck[a].x2 = 0;
                        deck[a].y1 = 0;
                        deck[a].y2 = 0;
                        
                        a = 0;
                        }    
                    }    
                }
                int defended = 0;
                if(attack == 1)
                {
                for(int b = 0; b <= deck.size(); b++) // again, ai tries to defend
                {
                    if((deck[b].place == 2)&&(defend(deck[b], deck[temp_pos])==1))    
                    {
                        defended = 1;
                        deck[b].place = 4;
                        deck[temp_pos].def_pos = b;
                        b = deck.size();
                        SendMessage(hwnd, WM_PAINT, 0,0);
                        turn = 1;
                    }    
                    
                }
                if(defended == 0)
                {
                    turn = 0;
                    failure(2);
                    draw();
                    
                } 
              }       
            }        
        
        
            if(turn == 3) //ai attacks player
            {   
                int temp_pos;
                int temp_pos2;
                for(int a = 0; a < deck.size(); a++)
                {
                  if((deck[a].place == 3)&&(deck[a].def_pos == 55))
                  {
                      temp_pos = a;
                      a = deck.size();
                  }     
                }       
     
                for(int a = deck.size(); a >= 0; a--) //select the card to defend
                {
                    if((glbl_x >= deck[a].x1) &&
                      (glbl_y >= deck[a].y1) &&
                      (glbl_x < deck[a].x2) &&
                      (glbl_y < deck[a].y2) &&
                      (deck[a].place==1))
                    {
                      temp_pos2 = a;
                    }
                                                             
                }
                
                if(defend(deck[temp_pos2],deck[temp_pos])==1)
                {
                    deck[temp_pos].def_pos = temp_pos2;
                    deck[temp_pos2].place = 4;
                    remove_cards();  
                    draw();
                    turn = 0;
                    PostMessage(hwnd, WM_PAINT, 0,0);                  
                }  
                
               
               
                
            }    
                
  
        
        
        
        
        SendMessage(hwnd, WM_PAINT, 0,0);
     
        }    
        break;
    case WM_MOUSEMOVE:
         {
         // get the position of the mouse
         int mouse_x = (int)LOWORD(lparam);
         int mouse_y = (int)HIWORD(lparam);
         glbl_x = mouse_x;
         glbl_y = mouse_y;
         
         // get the button state
         int buttons = (int)wparam;

         // get a graphics context
         hdc = GetDC(hwnd);

        // sprintf(buffer,"Mouse (X,Y) = (%d,%d,%d, %d)      ",mouse_x,mouse_y, turn, trump);
       //  TextOut(hdc, 0,0, buffer, strlen(buffer));


       //  sprintf(buffer,"Left Button = %d  ",((buttons & MK_LBUTTON) ? 1 : 0));
       //  TextOut(hdc, 0,32, buffer, strlen(buffer));
        

   	     // release the dc back
         ReleaseDC(hwnd, hdc);

         } break;


	case WM_PAINT: 
		{
		

        hdc = GetDC(hwnd);
        BeginPaint(hwnd,&ps);

        Rectangle(hdc, 0,0,680,480);
   	    if(story == 1)
        {
   
            if(total_story == 1)
            {            
                sprintf(buffer,"Napoleon Bonaparte - The famous French general who nearly took over the old world. ");
                TextOut(hdc, 10,10, buffer, strlen(buffer));
                sprintf(buffer,"One of your most feared opponents.");
                TextOut(hdc, 10,30, buffer, strlen(buffer));
            }   
            if(total_story == 2)
            {            
                sprintf(buffer,"Admiral Nelson  Not all battles are fought on land.");
                TextOut(hdc, 10,10, buffer, strlen(buffer));
                sprintf(buffer,"Grow your sea legs and take the battle on the high seas!");
                TextOut(hdc, 10,30, buffer, strlen(buffer));
           }            
            if(total_story == 3)
            {            
                sprintf(buffer,"Alexander the Great  He invaded Persia in some of histories most decisive battles.");
                TextOut(hdc, 10,10, buffer, strlen(buffer));
                sprintf(buffer,"See if you can figure out his fighting style");
                TextOut(hdc, 10,30, buffer, strlen(buffer));
            }                 
             if(total_story == 4)
            {            
                sprintf(buffer,"Cortez  Fight the Spanish Conquistadors for the new worlds gold. ");
                TextOut(hdc, 10,10, buffer, strlen(buffer));
            }                     
                                
        } 
        if(tutorial == 1)
        {
            
            sprintf(buffer,"This is the bottom card ");
            TextOut(hdc, 450,80, buffer, strlen(buffer)); 
            sprintf(buffer,"everybody sees it, its also ");
            TextOut(hdc, 450,100, buffer, strlen(buffer));                  
            sprintf(buffer,"the trump suit.");
            TextOut(hdc, 450,120, buffer, strlen(buffer));
                                                  
            sprintf(buffer,"This is the draw deck.");
            TextOut(hdc, 375,380, buffer, strlen(buffer));                          
            sprintf(buffer,"You want to get rid of all your cards and draw.");
            TextOut(hdc, 375,400, buffer, strlen(buffer));                            
            sprintf(buffer,"from here. You win when this is empty");
            TextOut(hdc, 375,420, buffer, strlen(buffer));                               
            sprintf(buffer,"And you have no more cards.");
            TextOut(hdc, 375,440, buffer, strlen(buffer)); 
                                           
            sprintf(buffer,"This is your hand.");
            TextOut(hdc, 175,440, buffer, strlen(buffer));                                    
                                       
            sprintf(buffer,"You Fight here. Cards with higher rank or trump win.");
            TextOut(hdc, 50,240, buffer, strlen(buffer));   
            tutorial = 0;                                       
                                             
                                                
         } 
        if(about == 1)
        {
            about = 0;
            sprintf(buffer,"Created by Peter Olejnik");
            TextOut(hdc, 10,10, buffer, strlen(buffer));       
            sprintf(buffer,"For the Fall 2004 CIS487 final.");
            TextOut(hdc, 10,30, buffer, strlen(buffer));                         
                              
                                                             
                                                                                    
        }          
   	    
   	    trump = deck[last_card].suit;
   	    if(deck[last_card].place ==0) cdtDraw(hdc, 425, 175, Cd(deck[last_card].rank, deck[last_card].suit) , mdFaceUp, 0);
   	    int counter = 0;
   	    
   	    for(int a = 0; a < deck.size();a++)
   	    {
   	            if((deck[a].place == 3) && (deck[a].rank > 4))
                {
                    cdtDraw(hdc, 50+counter, 185, Cd(deck[a].rank, deck[a].suit), mdFaceUp,0); 
                    deck[a].x1 = 50 + counter;
                    deck[a].y1 = 185;
                    deck[a].x2 = 100 + counter;
                    deck[a].y2 = 285;
                    if(deck[a].def_pos != 55)
                    {
                    cdtDraw(hdc, 65+counter, 200, Cd(deck[deck[a].def_pos].rank, deck[deck[a].def_pos].suit), mdFaceUp,0); 
                    deck[deck[a].def_pos].x1 = 65 + counter;
                    deck[deck[a].def_pos].y1 = 200;
                    deck[deck[a].def_pos].x2 = 115 + counter;
                    deck[deck[a].def_pos].y2 = 300;    
                        
                        
                    }
                      
                    counter=counter+75;
                }
  
   
     	}    

   	   
     	counter = 0;
   	    for(int a = 0; a < deck.size();a++)
   	    {
   	            if((deck[a].place == 0) && (deck[a].rank > 4))
                {
                    cdtDraw(hdc, 500+counter, 185+counter, cdFaceDown1, mdFaceDown,0); 
                    deck[a].x1 = 500 + counter;
                    deck[a].y1 = 185 + counter;
                    deck[a].x2 = 550 + counter;
                    deck[a].y2 = 285 + counter;
                    counter=counter+4;
                }
         
   	    }
            
        
        
        counter = 0;
        
   	    for(int a = 0; a < deck.size()+1;a++)
   	    {
   	            if(deck[a].place==1)
                {
                    cdtDraw(hdc, 20+counter, 320, Cd(deck[a].rank, deck[a].suit) , mdFaceUp, 0);
                    deck[a].x1 = 20 + counter;
                    deck[a].y1 = 320;
                    deck[a].x2 = 70+ counter;
                    deck[a].y2 = 420;
                    counter = counter + 50;
                }
   	        
   	    }
   	    
   	    counter = 0;
   	    for(int a = 0; a < deck.size()+1;a++)
   	    {
   	            if(deck[a].place==2)
                {
                    cdtDraw(hdc, 20+counter, 50, cdFaceDown1 , mdFaceDown, 0); 
                    deck[a].x1 = 20 + counter;
                    deck[a].y1 = 50;
                    deck[a].x2 = 70+ counter;
                    deck[a].y2 = 150;
                    counter = counter + 50;
                }
   	        
   	    }  
        EndPaint(hwnd,&ps);
        ReleaseDC(hwnd, hdc);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////
int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{


WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS                         ;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
winclass.hbrBackground = CreateSolidBrush(RGB(255, 255, 255));
winclass.hIcon = LoadIcon(hinstance, MAKEINTRESOURCE(ID_ICON1));
winclass.hIconSm = LoadIcon(hinstance, MAKEINTRESOURCE(ID_ICON1));
// save hinstance in global
hinstance_app = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "Durak", // title
						    WS_OVERLAPPEDWINDOW | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    900,650,  // initial width, height
						    HWND_DESKTOP,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;
cdtInit(&dxCard, &dyCard);
//PostMessage(hwnd, WM_USER, NEW_GAME,0);


CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "Random Game",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				150,500,	  // initial x,y
				125,35,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(100),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms
			    
CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "Story Game",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				150,535,	  // initial x,y
				125,35,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(200),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms
			    
			    
CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "Quit",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				385,500,	  // initial x,y
				75,75,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(300),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms

CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "Pass",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				50,500,	  // initial x,y
				75,75,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(400),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms

CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "Help",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				295,500,	  // initial x,y
				75,75,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(500),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms
CreateWindowEx(NULL,                  // extended style
               "button",              // class
			    "About",         // title
	   	        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				475,500,	  // initial x,y
				75,75,    // initial width, height
			    main_window_handle,	  // handle to parent 
			    (HMENU)(600),	  // handle to menu
			    hinstance,  // instance of this application
			    NULL);      // extra creation parms



// enter main event loop, but this time we use PeekMessage()
// instead of GetMessage() to retrieve messages
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
    // main game processing goes here
    
    int player1 = 0;
    int player2 = 0;
    for(int a = 0; a < deck.size(); a++)
    {
        if(deck[a].place == 1) player1++;
        if(deck[a].place == 2) player2++;
    }    
    
    if(player1 == 0)
    {
        PostMessage(hwnd, WM_USER, PLAYER_WINS,0);
    }   
    if(player2 == 0)
    {
        PostMessage(hwnd, WM_USER, CPU_WINS,0); 
    }       
   
    if(turn == 2)
    {
        for(int a = 0; a < deck.size(); a ++)
        {
            if(deck[a].place == 2)
            {
                deck[a].place = 3;
                attack_ctr++;
                a = deck.size();
            }    
        }
        PostMessage(hwnd, WM_PAINT, 0,0);    
        turn = 3;
    }    
    

	// Game_Main(); // or whatever your loop is called
	} // end while

// return to Windows like this
return(msg.wParam);

} // end WinMain

///////////////////////////////////////////////////////////


